package net.weasel.Vegetation;

import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.Player;

public final class Grass 
{
	public static void logOutput( String text ) { Vegetation.logOutput( text ); }
	public static boolean withinEnabledBiome( Block whichBlock ) { return Blocks.withinEnabledBiome( whichBlock ); }
	public static Block getTopBlock(World world, double X, double Z) { return Blocks.getTopBlock(world, X, Z); }

	public static void growGrass( Player player )
	{
		if( player == null ) return;
		
		if( player.getWorld().getTime() > 12000 && Vegetation.overGrowTicks > 0 ) 
		{
			if( Vegetation.overGrower != null ) Vegetation.overGrower.sendMessage( "Darkness falls and the overgrowth slows down." );
			Vegetation.overGrowTicks = 0;
		}
		
		if( Vegetation.debugging ) logOutput( "Growing grass.." );

		Integer V;
		Block currentBlock = null;
		
		currentBlock = Grass.getRandomGrassBlock( player );

		if( currentBlock != null )
		{
			V = currentBlock.getData() + 1;
				
			if( V > 10 ) V = 10;
    
			if( Vegetation.debugging ) logOutput( "Adjusting block " + currentBlock.getX() + "," + currentBlock.getY() + "," + currentBlock.getZ() );
			currentBlock.setData( (byte)(int)V );
			
			if( Vegetation.overGrowTicks > 0 )
			{
				Vegetation.overGrowTicks--;
				
				if( Vegetation.overGrowTicks == 0 )
				{
					Vegetation.overGrower.sendMessage( "Overgrowth completed." );
					Vegetation.overGrowTicks = 0;
				}
				if( Vegetation.overGrowTicks == 250 )
				{
					Vegetation.overGrower.sendMessage( "Overgrowth 75% done." );
				}
				if( Vegetation.overGrowTicks == 500 )
				{
					Vegetation.overGrower.sendMessage( "Overgrowth 50% done." );
				}
				if( Vegetation.overGrowTicks == 750 )
				{
					Vegetation.overGrower.sendMessage( "Overgrowth 25% done." );
				}
			}
		}
		else
			logOutput( "null grass block" );
	}

	public static Block getRandomGrassBlock( Player player )
    {
    	Block retVal = null;
    	Integer range = Vegetation.growthRange;
    	
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	
    	double minX = (pX - (range / 2));
    	double minZ = (pZ - (range / 2));

    	Block currentBlock;
    	double tX, tZ;

    	while( retVal == null )
    	{
    		tX = minX + Vegetation.generator.nextInt(range);
    		tZ = minZ + Vegetation.generator.nextInt(range);

        	currentBlock = getTopBlock( player.getWorld(), tX, tZ );
			
        	if( currentBlock != null )
        	{
	        	if( currentBlock.getTypeId() == 2 
	        	   && withinEnabledBiome( currentBlock ) == true
	        	   && currentBlock.getRelative(BlockFace.UP).getTypeId() == 0 )
	        		retVal = currentBlock;
	        	else
	        		retVal = null;
        	}
    	}

    	if( retVal.getTypeId() != 2 ) retVal = null;  
    	
    	if( Vegetation.debugging && retVal != null ) logOutput( "Found grass block: " + retVal.getX() + "," + retVal.getY() + "," + retVal.getZ() );
    	
    	return( retVal );
    }
    
    public static void mowTheGrass( Player player )
    {
    	Integer R = Math.round( Vegetation.growthRange / 2 );
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	    	
    	Block currentBlock = null;
    	
    	for( double X = (pX-R); X <= (pX+R); X++ )
    	{
    		for( double Z = (pZ-R); Z <= (pZ+R); Z++ )
    		{
    			currentBlock = getTopBlock(player.getWorld(), X, Z );
    			
    			if( currentBlock != null )
    			{
	    			if( currentBlock.getData() > 1 && currentBlock.getTypeId() == 2 ) 
	    			{
	    				currentBlock.setData( (byte) 1 );
	    			}
    			}
    		}
    	}
    }
}
