package net.weasel.Vegetation;

import java.util.ArrayList;

import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.Player;

public class Plants 
{
	public static boolean withinEnabledBiome( Block whichBlock ) { return( Blocks.withinEnabledBiome( whichBlock ) ); }
	public static boolean isEnabledPlant( Block whichBlock ) { return Blocks.isEnabledPlant( whichBlock ); }
	public static Block getRandomAdjacentEmptyBlock(Block targetBlock, Integer blockType ) { return( Blocks.getRandomAdjacentEmptyBlock( targetBlock, blockType ) ); }
	public static void logOutput( String text ) { Vegetation.logOutput( text ); }
	public static Block getTopBlock(World world, double X, double Z) { return Blocks.getTopBlock(world, X, Z); }
	
	public static void growPlant(Player player)
	{
		if( player == null ) return;
		if( Vegetation.debugging ) logOutput( "Spreading plants.." );

		Block currentBlock = null;

		currentBlock = Plants.getRandomPlantBlock( player );
				
		if( currentBlock != null )
		{
			if( Vegetation.debugging ) logOutput( "Found plant block: " + currentBlock.getTypeId() + " plant at " + currentBlock.getX() + "," + currentBlock.getY() + "," + currentBlock.getZ() + "." );

			Integer plantOnBlock = currentBlock.getTypeId();
					
			try
			{
				Block RB = Blocks.getRandomAdjacentEmptyBlock( currentBlock, plantOnBlock ).getRelative(BlockFace.UP);
				Block targetBlock = getTopBlock(player.getWorld(), (double)RB.getX(), (double)RB.getZ() ).getRelative(BlockFace.UP);
				
				if( targetBlock != null )
				{
					if( targetBlock.getTypeId() == 0 )
					{
						if( Vegetation.debugging ) logOutput( "Spreading " + currentBlock.getTypeId() + " plant at " + targetBlock.getX() + "," + targetBlock.getY() + "," + targetBlock.getZ() + "." );
					
						targetBlock.setType(currentBlock.getType() );
					}
				}
			}
				
			catch( Exception e )
			{
				// Do nothing..
			}
		}
	}

	public static Block getRandomPlantBlock( Player player )
    {
    	Block currentBlock = null;
    	
    	ArrayList<Block> plantBlocks = new ArrayList<Block>();
    	
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	
    	Integer minX = (int) (pX - (Vegetation.growthRange / 2));
    	Integer minZ = (int) (pZ - (Vegetation.growthRange / 2));
    	Integer maxX = (int) (pX + (Vegetation.growthRange / 2));
    	Integer maxZ = (int) (pZ + (Vegetation.growthRange / 2));

    	for( Integer X = minX; X <= maxX; X++ )
    	{
    		for( Integer Z = minZ; Z <= maxZ; Z++ )
    		{
    			currentBlock = getTopBlock(player.getWorld(), X, Z );
    			    			
            	if( currentBlock != null )
            	{
        			if( isEnabledPlant(currentBlock) 
        			 && withinEnabledBiome(currentBlock) == true )
	    			{
            			plantBlocks.add(currentBlock);
	    			}
            	}
    		}
    	}

    	if( plantBlocks.size() > 0 )
    	{
    		Integer R = Vegetation.generator.nextInt( plantBlocks.size() );

    		return( plantBlocks.get(R) );
    	}
    	else
    		return( null );
    }
}
